<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.expdict</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;expdict
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.expdict-module.html">Module pyxmpp.expdict</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-docstring">"""Dictionary with item expiration."""</tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">time</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">threading</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt class="py-name">__all__</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-string">'ExpiringDictionary'</tt><tt class="py-op">]</tt> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt id="link-0" class="py-name" targets="Variable pyxmpp.expdict.sentinel=pyxmpp.expdict-module.html#sentinel"><a title="pyxmpp.expdict.sentinel" class="py-name" href="#" onclick="return doclink('link-0', 'sentinel', 'link-0');">sentinel</a></tt> <tt class="py-op">=</tt> <tt class="py-name">object</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary"></a><div id="ExpiringDictionary-def"><a name="L29"></a><tt class="py-lineno"> 29</tt> <a class="py-toggle" href="#" id="ExpiringDictionary-toggle" onclick="return toggle('ExpiringDictionary');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html">ExpiringDictionary</a><tt class="py-op">(</tt><tt class="py-base-class">dict</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="ExpiringDictionary-expanded"><a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line">    <tt class="py-docstring">"""An extension to standard Python dictionary objects which implements item</tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"><tt class="py-docstring">    expiration.</tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"><tt class="py-docstring">    Each item in ExpiringDictionary has its expiration time assigned, after</tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-docstring">    which the item is removed from the mapping.</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"><tt class="py-docstring">    :Ivariables:</tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line"><tt class="py-docstring">        - `_timeouts`: a dictionary with timeout values and timeout callback for</tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"><tt class="py-docstring">          stored objects.</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"><tt class="py-docstring">        - `_default_timeout`: the default timeout value (in seconds from now).</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line"><tt class="py-docstring">        - `_lock`: access synchronization lock.</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">        - `_timeouts`: `dict`</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-docstring">        - `_default_timeout`: `int`</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"><tt class="py-docstring">        - `_lock`: `threading.RLock`"""</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line"> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line">    <tt class="py-name">__slots__</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-string">'_timeouts'</tt><tt class="py-op">,</tt><tt class="py-string">'_default_timeout'</tt><tt class="py-op">,</tt><tt class="py-string">'_lock'</tt><tt class="py-op">]</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.__init__"></a><div id="ExpiringDictionary.__init__-def"><a name="L48"></a><tt class="py-lineno"> 48</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.__init__-toggle" onclick="return toggle('ExpiringDictionary.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">default_timeout</tt><tt class="py-op">=</tt><tt class="py-number">300</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.__init__-expanded"><a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize an `ExpiringDictionary` object.</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-docstring">            - `default_timeout`: default timeout value for stored objects.</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"><tt class="py-docstring">            - `default_timeout`: `int`"""</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">        <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Method pyxmpp.cache.Cache.__init__()=pyxmpp.cache.Cache-class.html#__init__,Method pyxmpp.cache.CacheFetcher.__init__()=pyxmpp.cache.CacheFetcher-class.html#__init__,Method pyxmpp.cache.CacheItem.__init__()=pyxmpp.cache.CacheItem-class.html#__init__,Method pyxmpp.cache.CacheSuite.__init__()=pyxmpp.cache.CacheSuite-class.html#__init__,Method pyxmpp.client.Client.__init__()=pyxmpp.client.Client-class.html#__init__,Method pyxmpp.clientstream.ClientStream.__init__()=pyxmpp.clientstream.ClientStream-class.html#__init__,Method pyxmpp.error.ErrorNode.__init__()=pyxmpp.error.ErrorNode-class.html#__init__,Method pyxmpp.error.StanzaErrorNode.__init__()=pyxmpp.error.StanzaErrorNode-class.html#__init__,Method pyxmpp.error.StreamErrorNode.__init__()=pyxmpp.error.StreamErrorNode-class.html#__init__,Method pyxmpp.exceptions.BadRequestProtocolError.__init__()=pyxmpp.exceptions.BadRequestProtocolError-class.html#__init__,Method pyxmpp.exceptions.FeatureNotImplementedProtocolError.__init__()=pyxmpp.exceptions.FeatureNotImplementedProtocolError-class.html#__init__,Method pyxmpp.exceptions.JIDMalformedProtocolError.__init__()=pyxmpp.exceptions.JIDMalformedProtocolError-class.html#__init__,Method pyxmpp.exceptions.ProtocolError.__init__()=pyxmpp.exceptions.ProtocolError-class.html#__init__,Method pyxmpp.expdict.ExpiringDictionary.__init__()=pyxmpp.expdict.ExpiringDictionary-class.html#__init__,Method pyxmpp.interface_micro_impl.Attribute.__init__()=pyxmpp.interface_micro_impl.Attribute-class.html#__init__,Method pyxmpp.interface_micro_impl.InterfaceClass.__init__()=pyxmpp.interface_micro_impl.InterfaceClass-class.html#__init__,Method pyxmpp.iq.Iq.__init__()=pyxmpp.iq.Iq-class.html#__init__,Method pyxmpp.jabber.client.JabberClient.__init__()=pyxmpp.jabber.client.JabberClient-class.html#__init__,Method pyxmpp.jabber.clientstream.LegacyClientStream.__init__()=pyxmpp.jabber.clientstream.LegacyClientStream-class.html#__init__,Method pyxmpp.jabber.dataforms.Field.__init__()=pyxmpp.jabber.dataforms.Field-class.html#__init__,Method pyxmpp.jabber.dataforms.Form.__init__()=pyxmpp.jabber.dataforms.Form-class.html#__init__,Method pyxmpp.jabber.dataforms.Item.__init__()=pyxmpp.jabber.dataforms.Item-class.html#__init__,Method pyxmpp.jabber.dataforms.Option.__init__()=pyxmpp.jabber.dataforms.Option-class.html#__init__,Method pyxmpp.jabber.delay.Delay.__init__()=pyxmpp.jabber.delay.Delay-class.html#__init__,Method pyxmpp.jabber.disco.DiscoIdentity.__init__()=pyxmpp.jabber.disco.DiscoIdentity-class.html#__init__,Method pyxmpp.jabber.disco.DiscoInfo.__init__()=pyxmpp.jabber.disco.DiscoInfo-class.html#__init__,Method pyxmpp.jabber.disco.DiscoItem.__init__()=pyxmpp.jabber.disco.DiscoItem-class.html#__init__,Method pyxmpp.jabber.disco.DiscoItems.__init__()=pyxmpp.jabber.disco.DiscoItems-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomHandler.__init__()=pyxmpp.jabber.muc.MucRoomHandler-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomManager.__init__()=pyxmpp.jabber.muc.MucRoomManager-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomState.__init__()=pyxmpp.jabber.muc.MucRoomState-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomUser.__init__()=pyxmpp.jabber.muc.MucRoomUser-class.html#__init__,Method pyxmpp.jabber.muccore.HistoryParameters.__init__()=pyxmpp.jabber.muccore.HistoryParameters-class.html#__init__,Method pyxmpp.jabber.muccore.MucIq.__init__()=pyxmpp.jabber.muccore.MucIq-class.html#__init__,Method pyxmpp.jabber.muccore.MucItem.__init__()=pyxmpp.jabber.muccore.MucItem-class.html#__init__,Method pyxmpp.jabber.muccore.MucItemBase.__init__()=pyxmpp.jabber.muccore.MucItemBase-class.html#__init__,Method pyxmpp.jabber.muccore.MucPresence.__init__()=pyxmpp.jabber.muccore.MucPresence-class.html#__init__,Method pyxmpp.jabber.muccore.MucStanzaExt.__init__()=pyxmpp.jabber.muccore.MucStanzaExt-class.html#__init__,Method pyxmpp.jabber.muccore.MucStatus.__init__()=pyxmpp.jabber.muccore.MucStatus-class.html#__init__,Method pyxmpp.jabber.muccore.MucX.__init__()=pyxmpp.jabber.muccore.MucX-class.html#__init__,Method pyxmpp.jabber.muccore.MucXBase.__init__()=pyxmpp.jabber.muccore.MucXBase-class.html#__init__,Method pyxmpp.jabber.register.Register.__init__()=pyxmpp.jabber.register.Register-class.html#__init__,Method pyxmpp.jabber.vcard.VCard.__init__()=pyxmpp.jabber.vcard.VCard-class.html#__init__,Method pyxmpp.jabber.vcard.VCardAdr.__init__()=pyxmpp.jabber.vcard.VCardAdr-class.html#__init__,Method pyxmpp.jabber.vcard.VCardCategories.__init__()=pyxmpp.jabber.vcard.VCardCategories-class.html#__init__,Method pyxmpp.jabber.vcard.VCardEmail.__init__()=pyxmpp.jabber.vcard.VCardEmail-class.html#__init__,Method pyxmpp.jabber.vcard.VCardField.__init__()=pyxmpp.jabber.vcard.VCardField-class.html#__init__,Method pyxmpp.jabber.vcard.VCardGeo.__init__()=pyxmpp.jabber.vcard.VCardGeo-class.html#__init__,Method pyxmpp.jabber.vcard.VCardImage.__init__()=pyxmpp.jabber.vcard.VCardImage-class.html#__init__,Method pyxmpp.jabber.vcard.VCardJID.__init__()=pyxmpp.jabber.vcard.VCardJID-class.html#__init__,Method pyxmpp.jabber.vcard.VCardKey.__init__()=pyxmpp.jabber.vcard.VCardKey-class.html#__init__,Method pyxmpp.jabber.vcard.VCardLabel.__init__()=pyxmpp.jabber.vcard.VCardLabel-class.html#__init__,Method pyxmpp.jabber.vcard.VCardName.__init__()=pyxmpp.jabber.vcard.VCardName-class.html#__init__,Method pyxmpp.jabber.vcard.VCardOrg.__init__()=pyxmpp.jabber.vcard.VCardOrg-class.html#__init__,Method pyxmpp.jabber.vcard.VCardPrivacy.__init__()=pyxmpp.jabber.vcard.VCardPrivacy-class.html#__init__,Method pyxmpp.jabber.vcard.VCardSound.__init__()=pyxmpp.jabber.vcard.VCardSound-class.html#__init__,Method pyxmpp.jabber.vcard.VCardString.__init__()=pyxmpp.jabber.vcard.VCardString-class.html#__init__,Method pyxmpp.jabber.vcard.VCardTel.__init__()=pyxmpp.jabber.vcard.VCardTel-class.html#__init__,Method pyxmpp.jabberd.component.Component.__init__()=pyxmpp.jabberd.component.Component-class.html#__init__,Method pyxmpp.jabberd.componentstream.ComponentStream.__init__()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#__init__,Method pyxmpp.message.Message.__init__()=pyxmpp.message.Message-class.html#__init__,Method pyxmpp.presence.Presence.__init__()=pyxmpp.presence.Presence-class.html#__init__,Method pyxmpp.roster.Roster.__init__()=pyxmpp.roster.Roster-class.html#__init__,Method pyxmpp.roster.RosterItem.__init__()=pyxmpp.roster.RosterItem-class.html#__init__,Method pyxmpp.sasl.core.Challenge.__init__()=pyxmpp.sasl.core.Challenge-class.html#__init__,Method pyxmpp.sasl.core.ClientAuthenticator.__init__()=pyxmpp.sasl.core.ClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.core.Failure.__init__()=pyxmpp.sasl.core.Failure-class.html#__init__,Method pyxmpp.sasl.core.PasswordManager.__init__()=pyxmpp.sasl.core.PasswordManager-class.html#__init__,Method pyxmpp.sasl.core.Reply.__init__()=pyxmpp.sasl.core.Reply-class.html#__init__,Method pyxmpp.sasl.core.Response.__init__()=pyxmpp.sasl.core.Response-class.html#__init__,Method pyxmpp.sasl.core.ServerAuthenticator.__init__()=pyxmpp.sasl.core.ServerAuthenticator-class.html#__init__,Method pyxmpp.sasl.core.Success.__init__()=pyxmpp.sasl.core.Success-class.html#__init__,Method pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.__init__()=pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.__init__()=pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#__init__,Method pyxmpp.sasl.external.ExternalClientAuthenticator.__init__()=pyxmpp.sasl.external.ExternalClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.__init__()=pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.plain.PlainClientAuthenticator.__init__()=pyxmpp.sasl.plain.PlainClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.plain.PlainServerAuthenticator.__init__()=pyxmpp.sasl.plain.PlainServerAuthenticator-class.html#__init__,Method pyxmpp.stanza.Stanza.__init__()=pyxmpp.stanza.Stanza-class.html#__init__,Method pyxmpp.stanzaprocessor.StanzaProcessor.__init__()=pyxmpp.stanzaprocessor.StanzaProcessor-class.html#__init__,Method pyxmpp.stream.Stream.__init__()=pyxmpp.stream.Stream-class.html#__init__,Method pyxmpp.streambase.StreamBase.__init__()=pyxmpp.streambase.StreamBase-class.html#__init__,Method pyxmpp.streamsasl.StreamSASLMixIn.__init__()=pyxmpp.streamsasl.StreamSASLMixIn-class.html#__init__,Method pyxmpp.streamtls.StreamTLSMixIn.__init__()=pyxmpp.streamtls.StreamTLSMixIn-class.html#__init__,Method pyxmpp.streamtls.TLSSettings.__init__()=pyxmpp.streamtls.TLSSettings-class.html#__init__,Method pyxmpp.xmlextra.StreamHandler.__init__()=pyxmpp.xmlextra.StreamHandler-class.html#__init__,Method pyxmpp.xmlextra.StreamReader.__init__()=pyxmpp.xmlextra.StreamReader-class.html#__init__,Method pyxmpp.xmlextra._PythonReader.__init__()=pyxmpp.xmlextra._PythonReader-class.html#__init__,Method pyxmpp.xmlextra._SAXCallback.__init__()=pyxmpp.xmlextra._SAXCallback-class.html#__init__,Method pyxmpp.xmppstringprep.LookupFunction.__init__()=pyxmpp.xmppstringprep.LookupFunction-class.html#__init__,Method pyxmpp.xmppstringprep.LookupTable.__init__()=pyxmpp.xmppstringprep.LookupTable-class.html#__init__,Method pyxmpp.xmppstringprep.Profile.__init__()=pyxmpp.xmppstringprep.Profile-class.html#__init__"><a title="pyxmpp.cache.Cache.__init__
pyxmpp.cache.CacheFetcher.__init__
pyxmpp.cache.CacheItem.__init__
pyxmpp.cache.CacheSuite.__init__
pyxmpp.client.Client.__init__
pyxmpp.clientstream.ClientStream.__init__
pyxmpp.error.ErrorNode.__init__
pyxmpp.error.StanzaErrorNode.__init__
pyxmpp.error.StreamErrorNode.__init__
pyxmpp.exceptions.BadRequestProtocolError.__init__
pyxmpp.exceptions.FeatureNotImplementedProtocolError.__init__
pyxmpp.exceptions.JIDMalformedProtocolError.__init__
pyxmpp.exceptions.ProtocolError.__init__
pyxmpp.expdict.ExpiringDictionary.__init__
pyxmpp.interface_micro_impl.Attribute.__init__
pyxmpp.interface_micro_impl.InterfaceClass.__init__
pyxmpp.iq.Iq.__init__
pyxmpp.jabber.client.JabberClient.__init__
pyxmpp.jabber.clientstream.LegacyClientStream.__init__
pyxmpp.jabber.dataforms.Field.__init__
pyxmpp.jabber.dataforms.Form.__init__
pyxmpp.jabber.dataforms.Item.__init__
pyxmpp.jabber.dataforms.Option.__init__
pyxmpp.jabber.delay.Delay.__init__
pyxmpp.jabber.disco.DiscoIdentity.__init__
pyxmpp.jabber.disco.DiscoInfo.__init__
pyxmpp.jabber.disco.DiscoItem.__init__
pyxmpp.jabber.disco.DiscoItems.__init__
pyxmpp.jabber.muc.MucRoomHandler.__init__
pyxmpp.jabber.muc.MucRoomManager.__init__
pyxmpp.jabber.muc.MucRoomState.__init__
pyxmpp.jabber.muc.MucRoomUser.__init__
pyxmpp.jabber.muccore.HistoryParameters.__init__
pyxmpp.jabber.muccore.MucIq.__init__
pyxmpp.jabber.muccore.MucItem.__init__
pyxmpp.jabber.muccore.MucItemBase.__init__
pyxmpp.jabber.muccore.MucPresence.__init__
pyxmpp.jabber.muccore.MucStanzaExt.__init__
pyxmpp.jabber.muccore.MucStatus.__init__
pyxmpp.jabber.muccore.MucX.__init__
pyxmpp.jabber.muccore.MucXBase.__init__
pyxmpp.jabber.register.Register.__init__
pyxmpp.jabber.vcard.VCard.__init__
pyxmpp.jabber.vcard.VCardAdr.__init__
pyxmpp.jabber.vcard.VCardCategories.__init__
pyxmpp.jabber.vcard.VCardEmail.__init__
pyxmpp.jabber.vcard.VCardField.__init__
pyxmpp.jabber.vcard.VCardGeo.__init__
pyxmpp.jabber.vcard.VCardImage.__init__
pyxmpp.jabber.vcard.VCardJID.__init__
pyxmpp.jabber.vcard.VCardKey.__init__
pyxmpp.jabber.vcard.VCardLabel.__init__
pyxmpp.jabber.vcard.VCardName.__init__
pyxmpp.jabber.vcard.VCardOrg.__init__
pyxmpp.jabber.vcard.VCardPrivacy.__init__
pyxmpp.jabber.vcard.VCardSound.__init__
pyxmpp.jabber.vcard.VCardString.__init__
pyxmpp.jabber.vcard.VCardTel.__init__
pyxmpp.jabberd.component.Component.__init__
pyxmpp.jabberd.componentstream.ComponentStream.__init__
pyxmpp.message.Message.__init__
pyxmpp.presence.Presence.__init__
pyxmpp.roster.Roster.__init__
pyxmpp.roster.RosterItem.__init__
pyxmpp.sasl.core.Challenge.__init__
pyxmpp.sasl.core.ClientAuthenticator.__init__
pyxmpp.sasl.core.Failure.__init__
pyxmpp.sasl.core.PasswordManager.__init__
pyxmpp.sasl.core.Reply.__init__
pyxmpp.sasl.core.Response.__init__
pyxmpp.sasl.core.ServerAuthenticator.__init__
pyxmpp.sasl.core.Success.__init__
pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.__init__
pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.__init__
pyxmpp.sasl.external.ExternalClientAuthenticator.__init__
pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.__init__
pyxmpp.sasl.plain.PlainClientAuthenticator.__init__
pyxmpp.sasl.plain.PlainServerAuthenticator.__init__
pyxmpp.stanza.Stanza.__init__
pyxmpp.stanzaprocessor.StanzaProcessor.__init__
pyxmpp.stream.Stream.__init__
pyxmpp.streambase.StreamBase.__init__
pyxmpp.streamsasl.StreamSASLMixIn.__init__
pyxmpp.streamtls.StreamTLSMixIn.__init__
pyxmpp.streamtls.TLSSettings.__init__
pyxmpp.xmlextra.StreamHandler.__init__
pyxmpp.xmlextra.StreamReader.__init__
pyxmpp.xmlextra._PythonReader.__init__
pyxmpp.xmlextra._SAXCallback.__init__
pyxmpp.xmppstringprep.LookupFunction.__init__
pyxmpp.xmppstringprep.LookupTable.__init__
pyxmpp.xmppstringprep.Profile.__init__" class="py-name" href="#" onclick="return doclink('link-1', '__init__', 'link-1');">__init__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">)</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-2" class="py-name" targets="Variable pyxmpp.expdict.ExpiringDictionary._timeouts=pyxmpp.expdict.ExpiringDictionary-class.html#_timeouts"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-2', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">=</tt><tt class="py-op">{</tt><tt class="py-op">}</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-3" class="py-name" targets="Variable pyxmpp.expdict.ExpiringDictionary._default_timeout=pyxmpp.expdict.ExpiringDictionary-class.html#_default_timeout"><a title="pyxmpp.expdict.ExpiringDictionary._default_timeout" class="py-name" href="#" onclick="return doclink('link-3', '_default_timeout', 'link-3');">_default_timeout</a></tt><tt class="py-op">=</tt><tt class="py-name">default_timeout</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-4" class="py-name" targets="Variable pyxmpp.cache.CacheItem._lock=pyxmpp.cache.CacheItem-class.html#_lock,Variable pyxmpp.expdict.ExpiringDictionary._lock=pyxmpp.expdict.ExpiringDictionary-class.html#_lock"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-4', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">=</tt><tt class="py-name">threading</tt><tt class="py-op">.</tt><tt class="py-name">RLock</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.__delitem__"></a><div id="ExpiringDictionary.__delitem__-def"><a name="L60"></a><tt class="py-lineno"> 60</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.__delitem__-toggle" onclick="return toggle('ExpiringDictionary.__delitem__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#__delitem__">__delitem__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">key</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.__delitem__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.__delitem__-expanded"><a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-5" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-5', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line">            <tt class="py-keyword">del</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-6" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-6', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-7" class="py-name" targets="Method pyxmpp.expdict.ExpiringDictionary.__delitem__()=pyxmpp.expdict.ExpiringDictionary-class.html#__delitem__"><a title="pyxmpp.expdict.ExpiringDictionary.__delitem__" class="py-name" href="#" onclick="return doclink('link-7', '__delitem__', 'link-7');">__delitem__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">        <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-8" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-8', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.__getitem__"></a><div id="ExpiringDictionary.__getitem__-def"><a name="L68"></a><tt class="py-lineno"> 68</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.__getitem__-toggle" onclick="return toggle('ExpiringDictionary.__getitem__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#__getitem__">__getitem__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">key</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.__getitem__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.__getitem__-expanded"><a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-9" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-9', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-10" class="py-name" targets="Method pyxmpp.expdict.ExpiringDictionary._expire_item()=pyxmpp.expdict.ExpiringDictionary-class.html#_expire_item"><a title="pyxmpp.expdict.ExpiringDictionary._expire_item" class="py-name" href="#" onclick="return doclink('link-10', '_expire_item', 'link-10');">_expire_item</a></tt><tt class="py-op">(</tt><tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-11" class="py-name" targets="Method pyxmpp.expdict.ExpiringDictionary.__getitem__()=pyxmpp.expdict.ExpiringDictionary-class.html#__getitem__,Method pyxmpp.jabber.dataforms.Form.__getitem__()=pyxmpp.jabber.dataforms.Form-class.html#__getitem__,Method pyxmpp.jabber.dataforms.Item.__getitem__()=pyxmpp.jabber.dataforms.Item-class.html#__getitem__,Method pyxmpp.jabber.vcard.VCard.__getitem__()=pyxmpp.jabber.vcard.VCard-class.html#__getitem__,Method pyxmpp.roster.Roster.__getitem__()=pyxmpp.roster.Roster-class.html#__getitem__"><a title="pyxmpp.expdict.ExpiringDictionary.__getitem__
pyxmpp.jabber.dataforms.Form.__getitem__
pyxmpp.jabber.dataforms.Item.__getitem__
pyxmpp.jabber.vcard.VCard.__getitem__
pyxmpp.roster.Roster.__getitem__" class="py-name" href="#" onclick="return doclink('link-11', '__getitem__', 'link-11');">__getitem__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">        <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-12" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-12', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.pop"></a><div id="ExpiringDictionary.pop-def"><a name="L76"></a><tt class="py-lineno"> 76</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.pop-toggle" onclick="return toggle('ExpiringDictionary.pop');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#pop">pop</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">key</tt><tt class="py-op">,</tt><tt class="py-param">default</tt><tt class="py-op">=</tt><tt id="link-13" class="py-name"><a title="pyxmpp.expdict.sentinel" class="py-name" href="#" onclick="return doclink('link-13', 'sentinel', 'link-0');">sentinel</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.pop-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.pop-expanded"><a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-14" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-14', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-15" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._expire_item" class="py-name" href="#" onclick="return doclink('link-15', '_expire_item', 'link-10');">_expire_item</a></tt><tt class="py-op">(</tt><tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">            <tt class="py-keyword">del</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-16" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-16', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">default</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt id="link-17" class="py-name"><a title="pyxmpp.expdict.sentinel" class="py-name" href="#" onclick="return doclink('link-17', 'sentinel', 'link-0');">sentinel</a></tt><tt class="py-op">:</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-18" class="py-name" targets="Method pyxmpp.expdict.ExpiringDictionary.pop()=pyxmpp.expdict.ExpiringDictionary-class.html#pop"><a title="pyxmpp.expdict.ExpiringDictionary.pop" class="py-name" href="#" onclick="return doclink('link-18', 'pop', 'link-18');">pop</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">key</tt><tt class="py-op">,</tt><tt class="py-name">default</tt><tt class="py-op">)</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-19" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary.pop" class="py-name" href="#" onclick="return doclink('link-19', 'pop', 'link-18');">pop</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">        <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-20" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-20', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.__setitem__"></a><div id="ExpiringDictionary.__setitem__-def"><a name="L88"></a><tt class="py-lineno"> 88</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.__setitem__-toggle" onclick="return toggle('ExpiringDictionary.__setitem__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#__setitem__">__setitem__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">key</tt><tt class="py-op">,</tt><tt class="py-param">value</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.__setitem__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.__setitem__-expanded"><a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Method pyxmpp.expdict.ExpiringDictionary.set_item()=pyxmpp.expdict.ExpiringDictionary-class.html#set_item"><a title="pyxmpp.expdict.ExpiringDictionary.set_item" class="py-name" href="#" onclick="return doclink('link-21', 'set_item', 'link-21');">set_item</a></tt><tt class="py-op">(</tt><tt class="py-name">key</tt><tt class="py-op">,</tt><tt id="link-22" class="py-name" targets="Variable pyxmpp.cache.CacheItem.value=pyxmpp.cache.CacheItem-class.html#value"><a title="pyxmpp.cache.CacheItem.value" class="py-name" href="#" onclick="return doclink('link-22', 'value', 'link-22');">value</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.set_item"></a><div id="ExpiringDictionary.set_item-def"><a name="L91"></a><tt class="py-lineno"> 91</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.set_item-toggle" onclick="return toggle('ExpiringDictionary.set_item');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#set_item">set_item</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">key</tt><tt class="py-op">,</tt><tt class="py-param">value</tt><tt class="py-op">,</tt><tt class="py-param">timeout</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">timeout_callback</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.set_item-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.set_item-expanded"><a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">        <tt class="py-docstring">"""Set item of the dictionary.</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line"><tt class="py-docstring">            - `key`: the key.</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line"><tt class="py-docstring">            - `value`: the object to store.</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line"><tt class="py-docstring">            - `timeout`: timeout value for the object (in seconds from now).</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line"><tt class="py-docstring">            - `timeout_callback`: function to be called when the item expires.</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line"><tt class="py-docstring">              The callback should accept none, one (the key) or two (the key</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line"><tt class="py-docstring">              and the value) arguments.</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line"><tt class="py-docstring">            - `key`: any hashable value</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line"><tt class="py-docstring">            - `value`: any python object</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line"><tt class="py-docstring">            - `timeout`: `int`</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line"><tt class="py-docstring">            - `timeout_callback`: callable"""</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-23" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-23', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-24" class="py-name" targets="Method pyxmpp.cache.CacheFetcher.timeout()=pyxmpp.cache.CacheFetcher-class.html#timeout"><a title="pyxmpp.cache.CacheFetcher.timeout" class="py-name" href="#" onclick="return doclink('link-24', 'timeout', 'link-24');">timeout</a></tt><tt class="py-op">:</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">                <tt id="link-25" class="py-name"><a title="pyxmpp.cache.CacheFetcher.timeout" class="py-name" href="#" onclick="return doclink('link-25', 'timeout', 'link-24');">timeout</a></tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._default_timeout" class="py-name" href="#" onclick="return doclink('link-26', '_default_timeout', 'link-3');">_default_timeout</a></tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-27', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt class="py-name">time</tt><tt class="py-op">.</tt><tt class="py-name">time</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">+</tt><tt id="link-28" class="py-name"><a title="pyxmpp.cache.CacheFetcher.timeout" class="py-name" href="#" onclick="return doclink('link-28', 'timeout', 'link-24');">timeout</a></tt><tt class="py-op">,</tt><tt class="py-name">timeout_callback</tt><tt class="py-op">)</tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-29" class="py-name" targets="Method pyxmpp.expdict.ExpiringDictionary.__setitem__()=pyxmpp.expdict.ExpiringDictionary-class.html#__setitem__"><a title="pyxmpp.expdict.ExpiringDictionary.__setitem__" class="py-name" href="#" onclick="return doclink('link-29', '__setitem__', 'link-29');">__setitem__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">key</tt><tt class="py-op">,</tt><tt id="link-30" class="py-name"><a title="pyxmpp.cache.CacheItem.value" class="py-name" href="#" onclick="return doclink('link-30', 'value', 'link-22');">value</a></tt><tt class="py-op">)</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">        <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-31" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-31', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary.expire"></a><div id="ExpiringDictionary.expire-def"><a name="L115"></a><tt class="py-lineno">115</tt> <a class="py-toggle" href="#" id="ExpiringDictionary.expire-toggle" onclick="return toggle('ExpiringDictionary.expire');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#expire">expire</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary.expire-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary.expire-expanded"><a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line">        <tt class="py-docstring">"""Do the expiration of dictionary items.</tt> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line"><tt class="py-docstring">        Remove items that expired by now from the dictionary."""</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-32" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-32', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">k</tt> <tt class="py-keyword">in</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-33" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-33', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">.</tt><tt class="py-name">keys</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-34" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._expire_item" class="py-name" href="#" onclick="return doclink('link-34', '_expire_item', 'link-10');">_expire_item</a></tt><tt class="py-op">(</tt><tt class="py-name">k</tt><tt class="py-op">)</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line">        <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-35" class="py-name"><a title="pyxmpp.cache.CacheItem._lock
pyxmpp.expdict.ExpiringDictionary._lock" class="py-name" href="#" onclick="return doclink('link-35', '_lock', 'link-4');">_lock</a></tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line"> </tt>
<a name="ExpiringDictionary._expire_item"></a><div id="ExpiringDictionary._expire_item-def"><a name="L126"></a><tt class="py-lineno">126</tt> <a class="py-toggle" href="#" id="ExpiringDictionary._expire_item-toggle" onclick="return toggle('ExpiringDictionary._expire_item');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.expdict.ExpiringDictionary-class.html#_expire_item">_expire_item</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">key</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ExpiringDictionary._expire_item-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ExpiringDictionary._expire_item-expanded"><a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">        <tt class="py-docstring">"""Do the expiration of a dictionary item.</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line"><tt class="py-docstring">        Remove the item if it has expired by now.</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line"><tt class="py-docstring">            - `key`: key to the object.</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line"><tt class="py-docstring">            - `key`: any hashable value"""</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line">        <tt class="py-op">(</tt><tt id="link-36" class="py-name"><a title="pyxmpp.cache.CacheFetcher.timeout" class="py-name" href="#" onclick="return doclink('link-36', 'timeout', 'link-24');">timeout</a></tt><tt class="py-op">,</tt><tt class="py-name">callback</tt><tt class="py-op">)</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-37" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-37', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-38" class="py-name"><a title="pyxmpp.cache.CacheFetcher.timeout" class="py-name" href="#" onclick="return doclink('link-38', 'timeout', 'link-24');">timeout</a></tt><tt class="py-op">&lt;=</tt><tt class="py-name">time</tt><tt class="py-op">.</tt><tt class="py-name">time</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">            <tt class="py-name">item</tt> <tt class="py-op">=</tt> <tt class="py-name">dict</tt><tt class="py-op">.</tt><tt id="link-39" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary.pop" class="py-name" href="#" onclick="return doclink('link-39', 'pop', 'link-18');">pop</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line">            <tt class="py-keyword">del</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-40" class="py-name"><a title="pyxmpp.expdict.ExpiringDictionary._timeouts" class="py-name" href="#" onclick="return doclink('link-40', '_timeouts', 'link-2');">_timeouts</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">callback</tt><tt class="py-op">:</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">                    <tt class="py-name">callback</tt><tt class="py-op">(</tt><tt class="py-name">key</tt><tt class="py-op">,</tt><tt class="py-name">item</tt><tt class="py-op">)</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt> <tt class="py-name">TypeError</tt><tt class="py-op">:</tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line">                    <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">                        <tt class="py-name">callback</tt><tt class="py-op">(</tt><tt class="py-name">key</tt><tt class="py-op">)</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">                    <tt class="py-keyword">except</tt> <tt class="py-name">TypeError</tt><tt class="py-op">:</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line">                        <tt class="py-name">callback</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line"> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:08 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
